.686
.xmm

ifndef SlenUseAlgos
  SlenUseAlgos	= 1			; default: UseJJ, includes CheckSSE2
endif
UseJJ	= SlenUseAlgos and 1
UseLingo	= SlenUseAlgos and 2
UseNightWare	= SlenUseAlgos and 4

  ifndef CheckSSE2
	CheckSSE2 = UseJJ			; enables a check for SSE2; timings not affected (+1 cycle), plus 76 bytes
  endif

  if UseJJ
  	StrLenAlgo$ equ <strlen32s>
  elseif UseLingo
  	StrLenAlgo$ equ <strlen64B>
  else
  	StrLenAlgo$ equ <NWStrLen>
  endif

strlen32s	PROTO:DWORD	; jj2007
strlen64B	PROTO:DWORD	; Lingo
NWStrLen	PROTO:DWORD	; NightWare 

len MACRO ptr:REQ
  invoke StrLenAlgo$, ptr
  EXITM <eax>
ENDM

TestMasmVersion MACRO
  ifidn @Version, <614>
	echo ####################################################
	echo
	echo You cannot use the SSE2 library with ml.exe version 614, sorry
	echo
	echo ####################################################
	.err
  endif
ENDM

.data?
MbSSE2	dd ?
MbGlobRet	dd ?
.code

	TestMasmVersion

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

If UseJJ
align 16	; jj2007, 13 March 2007, 80 bytes; 0.176 cycles/byte at 16k on Celeron M (0.3 on P4)
strlen32s proc src:DWORD		; with lots of inspiration from Lingo, NightWare and Agner Fog
	if CheckSSE2
		cmp MbSSE2, 2
		jb NoSSE2
	endif
	pop eax			; trash the return address
	pop eax			; the src pointer
	pxor xmm0, xmm0		; zero for comparison (no longer needed for xmm1 - thanks, NightWare)
	movups xmm1, [eax]	; move 16 bytes into xmm1, unaligned (adapted from Lingo/NightWare)
	pcmpeqb xmm1, xmm0	; set bytes in xmm1 to FF if nullbytes found in xmm1
	mov edx, eax		; save pointer to string
	pmovmskb eax, xmm1	; set byte mask in eax
	bsf eax, eax		; bit scan forward
	jne Lt16			; less than 16 bytes, we are done
	mov [esp-12], edx		; edx preserved because Masm32 szLen preserves it
	and edx, -16		; align initial pointer to 16-byte boundary
	lea eax, [edx+16]		; aligned pointer + 16 (first 0..15 dealt with by movups above)

@@:	pcmpeqb xmm0, [eax]	; ---- inner loop inspired by Lingo, with adaptions -----
	pcmpeqb xmm1, [eax+16]	; compare packed bytes in [m128] and xmm1 for equality
	lea eax, [eax+32]		; len counter (moving up lea or add costs 3 cycles for the 191 byte string)
	por xmm1, xmm0		; or them: one of the mem locations may contain a nullbyte
	pmovmskb edx, xmm1	; set byte mask in edx
	test edx, edx
	jz @B
@@:	sub eax, [esp-4]		; subtract original src pointer
	shl edx, 16		; create space for the ecx bytes
	push ecx			; all registers preserved, except edx and eax = return value
	pmovmskb ecx, xmm0	; set byte mask in ecx (has to be repeated, sorry)
	or edx, ecx		; combine xmm0 and xmm1 results
	bsf edx, edx		; bit scan for the index
	pop ecx
	lea eax, [eax+edx-32]	; add scan index
	mov edx, [esp-12]		; for saving edx, we use a free stack slot
Lt16:	jmp dword ptr [esp-4-4]	; ret address, one arg - the Lingo style equivalent to ret 4 ;-)

if CheckSSE2
NoSSE2:	.if MbSSE2==0
		call ChkSSE2	; if SSE2, next time we'll use the faster algo
	.endif
	pop MbGlobRet		; save the return address to pop...
	call crt_strlen
	add esp, 4
	jmp MbGlobRet
endif
strlen32s endp
strlen32se:

if CheckSSE2
ChkSSE2 proc			; exactly 40 bytes
	pushad
	push 1
	pop eax
	db 0Fh, 0A2h	; cpuid 1
	xor eax, eax
	xor esi, esi
	bt edx, 25		; edx bit 25, SSE1
	adc eax, esi
	bt edx, 26		; edx bit 26, SSE2
	adc eax, esi
	bt ecx, esi		; ecx bit 0, SSE3 (esi=0)
	adc eax, esi
	bt ecx, 9		; ecx bit 9, SSE4
	adc eax, esi
	mov MbSSE2, eax
	popad
	ret
ChkSSE2 endp
endif
endif					; ------------------------------- end UseJJ

if UseLingo
align 16
db		8Dh,0A4h,24h,0,0,0,0,8Dh,48h,0,10h 
strlen64B		proc szBuffer : dword
	pop ecx
	pop eax
	movdqu xmm2, [eax]
	; dd 106F0FF3h
	pxor xmm0, xmm0
	pcmpeqb xmm2, xmm0
	pxor xmm1, xmm1
	pmovmskb edx, xmm2
	test edx, edx
	jz @f
	bsf eax, edx
	jmp ecx
@@:
	lea ecx, [eax+16]
	and eax, -16
@@:
	pcmpeqb xmm0, [eax+16]
	pcmpeqb xmm1, [eax+32]
	por xmm1, xmm0
	add eax, 32
	pmovmskb edx, xmm1
	test edx, edx
	jz @B
	shl edx, 16
	sub eax, ecx
	pmovmskb ecx, xmm0
	or edx, ecx
	mov ecx, [esp-8]
	bsf edx, edx
	add eax, edx
	jmp ecx
strlen64B endp
strlen64Be:
endif					; ------------------------------- end UseLingo

if UseNightWare
NWStrLen PROC src:DWORD	;; [url=http://www.masm32.com/board/index.php?topic=1807.msg81075#msg81075]Nightware, 10.03.2009[/url]
	push ecx		;; empiler ecx
	push edx		;; empiler edx
	push esi
	mov esi, [esp+4+3*4]
	mov edx,esi		;; placer l'adresse de dpart dans edx
	pxor XMM0,XMM0		;; ) effacer XMM0 et XMM1 (ce sera nos registres de comparaison)
	pxor XMM1,XMM1		;; )
; ici, on teste un bloc de x caractres (dpend de l'alignement), pour voir s'il existe un 0
	movdqu XMM2,OWORD PTR [edx]	;; placer l'oword  l'adresse en edx dans XMM2
	; dd 126F0FF3h
	and edx,0FFFFFFF0h		;; conserver l'alignement 16 prcdant dans edx
	pcmpeqb XMM0,XMM2		;; comparer XMM2  XMM0
	pcmpeqb XMM1,OWORD PTR [edx+16]		;; comparer l'oword  l'adresse en edx+16  XMM1
	por XMM1,XMM0		;; fusionner XMM1 et XMM0
	pmovmskb eax,XMM1		;; gnrer le masque de XMM1 dans eax
	test eax,eax		;; fixer les flags de eax
	jz Label1		;; si c'est gal  0 (pas de 0 trouv), aller Label1
; ici, on va chercher le 0 dans le bloc de x caractres
	shl eax,16		;; dcaler eax (qui contient dj le masque XMM1)  gauche d'un dword/2
	mov ecx,esi		;; placer l'adresse originelle dans ecx
	sub ecx,edx		;; soustraire l'alignement prcdant
	shr eax,cl		;; dcaler eax  droite, correspondant au dcalage de l'alignement
	pmovmskb ecx,XMM0		;; gnrer le masque de XMM0 dans ecx
	or eax,ecx		;; fusionner ecx  eax
	bsf eax,eax		;; scanner le premier bit arm de eax  partir de la droite
	pop esi
	pop edx		;; dsempiler edx
	pop ecx		;; dsempiler ecx
	ret 4		;; retourner (sortir de la procdure)

	nop		;; ) alignement ncessaire pour un meilleur rendement
	nop		;; )
	nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; nop		;; )
; ici, on teste un bloc de 32 caractres, pour voir s'il existe un 0
Label1: add edx,OWORD*2		;; ajouter 32 (notre pas de progression)  edx
	pcmpeqb XMM0,OWORD PTR [edx]		;; comparer l'oword  l'adresse en edx  XMM0
	pcmpeqb XMM1,OWORD PTR [edx+16]		;; comparer l'oword  l'adresse en edx+16  XMM1
	por XMM1,XMM0		;; fusionner XMM1 et XMM0
	pmovmskb eax,XMM1		;; gnrer le masque de XMM1 dans eax
	test eax,eax		;; fixer les flags de eax
	jz Label1		;; si c'est gal  0 (pas de 0 trouv), aller Label1
; ici, on va chercher le 0 dans le bloc de 32 caractres
	pmovmskb ecx,XMM0		;; gnrer le masque de XMM0 dans ecx
	shl eax,16		;; dcaler eax (qui contient dj le masque XMM1)  gauche d'un dword/2
	or eax,ecx		;; fusionner ecx  eax
	sub edx,esi		;; enlever l'adresse de dpart  edx
	bsf eax,eax		;; scanner le premier bit arm de eax  partir de la droite
	add eax,edx		;; ajouter edx  eax pour obtenir la taille finale
	pop esi
	pop edx		;; dsempiler edx
	pop ecx		;; dsempiler ecx
	ret 4		;; retourner (sortir de la procdure)
NWStrLen ENDP
NWStrLene:
endif					; ------------------------------- end UseNightWare
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
